/* **********************************************************
   XLMCURVE.H
   ==========
   This file contains function prototypes for the various
   curve fitting functions. The functions are copyrighted
   by Quinn-Curtis and are available in their Science & 
   Engineering Tools. The modifications to these routines
   are minor and consist primarily of changing pointer types
   to FAR pointers.
   ******************************************************** */

#ifndef realtype
   #define realtype double
#endif

/* ----------------------------------------------------------
	CURVEFIT.C
   ---------------------------------------------------------- */
BOOL _PolyCurveFit(LPREAL lpIndvar,LPREAL lpDepvar,int numobs,int order,
              LPREAL lpCoef,LPREAL lpYest,LPREAL lpResid,NPREAL see,
		  LPREAL lpCoefsig,NPREAL rsq,NPREAL r,NPREAL dferror);
/* ----------------------------------------------------------
	MULREG.C
   ---------------------------------------------------------- */
void  MatTxTiX(LPREAL lpAryin,int numrow,int numcol,LPREAL lpAryout);
void MatYTiX(LPREAL lpAryy,LPREAL lpAryx,int numrow,
		    int numcol,LPREAL lpAryout);
void ResAnalysis(LPREAL lpRegmat, LPREAL lpYmat,LPREAL regcoef,
		 LPREAL aryinv, int numrow,int numcol,LPREAL yest,
		 LPREAL resid, NPREAL see,LPREAL coefsig,
		 NPREAL rsq,NPREAL r);
BOOL MultipleReg(LPREAL lpIndvardat,LPREAL lpDepvardat,int numiv,int numobs,
            LPREAL lpRegcoef,LPREAL lpYest,LPREAL lpResid,NPREAL see,
            LPREAL lpCoefsig,NPREAL rsq,NPREAL r,char *regerror);
/* ----------------------------------------------------------
	GJ.C
   ---------------------------------------------------------- */
void gjswap(LPREAL s1,LPREAL s2);
BOOL GaussJordan( LPREAL coefary,LPREAL constary,
		  int numcol,LPREAL solcoef, LPREAL invary,
                  NPREAL det);
/* ----------------------------------------------------------
	Cubic Splines
   ---------------------------------------------------------- */

void tridiag(LPREAL mat,int n,LPREAL vec);
BOOL _CubicSplines(LPREAL x,LPREAL y,int n,LPREAL s);
realtype PolyCalc(realtype XIn,LPREAL CoefVector,int order);
BOOL _CalcSpline(LPREAL xv,LPREAL coef,int n,LPREAL lpX,LPREAL y);
/* ----------------------------------------------------------
	SMOOTH.C
   ---------------------------------------------------------- */

void _DataSmoothSg(LPREAL dataset,int numdat,int smoothnum,
                 int derivnum, LPREAL smoothdata);
void _DataSmoothWeights(LPREAL dataset,int numdat,int smoothnum,
                       LPREAL weights,LPREAL lpdivisor,
					   LPREAL smoothdata);
double CalcOverflow(realtype num);